﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AntiAircraftGun
{
    internal class AntiAircraftGunCompareByColor : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xAntiAircraftGun = x as DrawingObjectAntiAircraftGun;
            var yAntiAircraftGun = y as DrawingObjectAntiAircraftGun;
            if (xAntiAircraftGun == null && yAntiAircraftGun == null)
            {
                return 0;
            }
            if (xAntiAircraftGun == null && yAntiAircraftGun != null)
            {
                return 1;
            }
            if (xAntiAircraftGun != null && yAntiAircraftGun == null)
            {
                return -1;
            }
            if (xAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor == yAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor)
            {
                return 0;
            }
            if (xAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.R.CompareTo(yAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.R) == 0)
            {
                if (xAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.G.CompareTo(yAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.G) == 0)
                {
                    return xAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.B.CompareTo(yAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.B);
                }
                else return xAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.G.CompareTo(yAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.G);
            }
            else return xAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.R.CompareTo(yAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.BodyColor.R);
        }
    }
}
