﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AntiAircraftGun
{
    internal class AntiAircraftGunCompareByType : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xAntiAircraftGun = x as DrawingObjectAntiAircraftGun;
            var yAntiAircraftGun = y as DrawingObjectAntiAircraftGun;
            if (xAntiAircraftGun == null && yAntiAircraftGun == null)
            {
                return 0;
            }
            if (xAntiAircraftGun == null && yAntiAircraftGun != null)
            {
                return 1;
            }
            if (xAntiAircraftGun != null && yAntiAircraftGun == null)
            {
                return -1;
            }
            if (xAntiAircraftGun.GetAntiAircraftGun.GetType().Name != yAntiAircraftGun.GetAntiAircraftGun.GetType().Name)
            {
                if (xAntiAircraftGun.GetAntiAircraftGun.GetType().Name == "DrawingAntiAircraftGun")
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.Speed.CompareTo(yAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.Weight.CompareTo(yAntiAircraftGun.GetAntiAircraftGun.AntiAircraftGun.Weight);
        }
    }
}
