﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace AntiAircraftGun
{
    [Serializable]
    internal class AntiAircraftGunNotFoundException : ApplicationException
    {
        public AntiAircraftGunNotFoundException(int i) : base($"Не найден объект по позиции {i}") { }
        public AntiAircraftGunNotFoundException() : base() { }
        public AntiAircraftGunNotFoundException(string message) : base(message) { }
        public AntiAircraftGunNotFoundException(string message, Exception exception) : base(message, exception) { }
        protected AntiAircraftGunNotFoundException(SerializationInfo info, StreamingContext contex) : base(info, contex) { }
    }
}
